/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2016
* 
*        (as is).
*     .
********************************************************************************
*/




#ifndef __CLOUD_BOARD_H
#define __CLOUD_BOARD_H

#include "stm32f030x6.h"

// /
#define       LEDS_GPIO                    GPIOA
#define       ROW1_PIN                     0
#define       ROW2_PIN                     1
#define       ROW3_PIN                     2
#define       ROW4_PIN                     3
#define       ROW5_PIN                     4
#define       ROWS_MASK                    ((1 << ROW1_PIN) | (1 << ROW2_PIN) | (1 << ROW3_PIN) | (1 << ROW4_PIN) | (1 << ROW5_PIN))

#define       COL1_PIN                     5
#define       COL2_PIN                     6
#define       COL3_PIN                     9
#define       COL4_PIN                     10
#define       COLS_MASK                    ((uint16_t) ((1 << COL1_PIN) | (1 << COL2_PIN) | (1 << COL3_PIN) | (1 << COL4_PIN)))

#define       BUZZ_GPIO                    GPIOF
#define       BUZZ_PIN                     1

//   
#define       TIME_BASE_TIMER              TIM17
#define       TIME_BASE_TIMER_ENR          APB2ENR
#define       TIME_BASE_TIMER_CLK_EN       RCC_APB2ENR_TIM17EN
#define       TIME_BASE_TIMER_IRQ          TIM17_IRQn

//     
#define       RAIN_TIMER                   TIM14
#define       RAIN_TIMER_ENR               APB1ENR
#define       RAIN_TIMER_CLK_EN            RCC_APB1ENR_TIM14EN
#define       RAIN_TIMER_IRQ               TIM14_IRQn

//  
#define       THUNDER_TIMER                TIM16
#define       THUNDER_TIMER_ENR            APB2ENR
#define       THUNDER_TIMER_CLK_EN         RCC_APB2ENR_TIM16EN
#define       THUNDER_TIMER_IRQ            TIM16_IRQn

#define       COLS_NUM                     4
#define       ROWS_NUM                     5

//     
#define       RAIN_INIT_POS_COL1           1
#define       RAIN_INIT_POS_COL2           0
#define       RAIN_INIT_POS_COL3           1
#define       RAIN_INIT_POS_COL4           2

//
#define       THUNDER                      (1 << 0)
#define       LIGHTNING_1                  (1 << 1)
#define       LIGHTNING_2                  (1 << 2)
#define       LIGHTNING_3                  (1 << 3)
#define       LIGHTNING_4                  (1 << 4)
#define       LIGHTNING                    (LIGHTNING_1 | LIGHTNING_2 | LIGHTNING_3 | LIGHTNING_4)
#define       RAIN                         (1 << 5)

//  
#define       ACTIVE_RAIN_1                (1 << 0)
#define       ACTIVE_RAIN_2                (1 << 1)
#define       ACTIVE_RAIN_3                (1 << 2)
#define       ACTIVE_RAIN_4                (1 << 3)

//  
#define       SCENE_1_PAUSE                ((uint16_t) 960)//0,25 seconds
#define       SCENE_2_PAUSE                ((uint16_t) 4)
#define       SCENE_3_PAUSE                ((uint16_t) 240)
#define       SCENE_4_PAUSE                ((uint16_t) 480)
#define       SCENE_5_PAUSE                ((uint16_t) 240)
#define       SCENE_6_PAUSE                ((uint16_t) 120)

// 
#define       SCENE_1_DURATION             ((uint16_t) 3)//0,25 seconds
#define       SCENE_2_DURATION             ((uint16_t) 3)
#define       SCENE_3_DURATION             ((uint16_t) 12)
#define       SCENE_4_DURATION             ((uint16_t) 120)
#define       SCENE_5_DURATION             ((uint16_t) 120)
#define       SCENE_6_DURATION             ((uint16_t) 120)

//  
#define       SCENE_1_TIME                 SCENE_1_PAUSE
#define       SCENE_2_TIME                 ((uint16_t) (SCENE_1_TIME + SCENE_1_DURATION + SCENE_2_PAUSE))
#define       SCENE_3_TIME                 ((uint16_t) (SCENE_2_TIME + SCENE_2_DURATION + SCENE_3_PAUSE))
#define       SCENE_4_TIME                 ((uint16_t) (SCENE_3_TIME + SCENE_3_DURATION + SCENE_4_PAUSE))
#define       SCENE_5_TIME                 ((uint16_t) (SCENE_4_TIME + SCENE_4_DURATION + SCENE_5_PAUSE))
#define       SCENE_6_TIME                 ((uint16_t) (SCENE_5_TIME + SCENE_5_DURATION + SCENE_6_PAUSE))

//   
#define       END_TIME                     (SCENE_6_TIME + SCENE_6_DURATION)

// 
#define       LIGHTNING_DURATION           15
#define       LIGHTNING_UPDATE             10



void Cloud_Init(void);

void TIME_BASE_TIMER_ISR(void);

void RAIN_TIMER_ISR(void);

void THUNDER_TIMER_ISR(void);



#endif //__CLOUD_BOARD_H